#TL - 150915 - thibault.leroy@pierroton.inra.fr

###########GENERAL INFO###########
cd /work2/project/genoak/tleroy/RawData_3P/haplov2.3/
slidingwindows=$(echo "250000" | bc) # length of the sliding windows
infileSNPinfo=$(echo "3P.haplov2.bam.pisorted.dedup.pileup.mincov100-maxcov200.vcf.withoutindel.sed.siteshz")  # file containing all detected SNPs see CL 15095
infileScaffoldSumStat=$(echo "haplome_v2.3_GCscaffold_090216_pourR.txt") #file containing les sumstat par scaffold (nb bases, nb unknown (=N), ...
infileslidingwindowsSumStat=$(echo "haplome_v2.3_sliwin10kb_090216_pourR.txt") # file containing sumstats per windows of each scaff 
outfile=$(echo "3P.haplov2.bam.pisorted.dedup.pileup.mincov100-maxcov200.vcf.withoutindel.sed.siteshz.res1mb-Sldiwin250kb") #outname
###########SCRIPT################"
# generate file with HZ snp per scaffold
for i in {0..9}; do 
	scaffoldname=$(echo "Sc000000""$i")
	grep "$scaffoldname" $infileSNPinfo > ./HZscaffoldparscaffold/3P.freqSNP.siteshz.$scaffoldname
done
for i in {10..99}; do 
        scaffoldname=$(echo "Sc00000""$i")
        grep "$scaffoldname" $infileSNPinfo > ./HZscaffoldparscaffold/3P.freqSNP.siteshz.$scaffoldname
done
for i in {100..999}; do 
        scaffoldname=$(echo "Sc0000""$i")
        grep "$scaffoldname" $infileSNPinfo > ./HZscaffoldparscaffold/3P.freqSNP.siteshz.$scaffoldname
done
for i in {1000..1408}; do 
        scaffoldname=$(echo "Sc000""$i")
        grep "$scaffoldname" $infileSNPinfo > ./HZscaffoldparscaffold/3P.freqSNP.siteshz.$scaffoldname
done
# header de l'outfile
echo "scaffold	startwind	endwind	nbSNPhz	scaff2	scaffsize	stardwind2	GCcount	othercount	ACGTcount	Ncount	GCpercent	Npercent	otherpercent	propSNPhzUncorrectedbyNcount	propSNPhzCorrectedbyNcount" > $outfile
# loop per each scaffold (= each file)
for i in ./HZscaffoldparscaffold/3P.freqSNP.siteshz.*; do
	less $i | head -1 > ./HZscaffoldparscaffold/tmpheader
	scaffold=$(awk '{print $1}' ./HZscaffoldparscaffold/tmpheader)
	grep "$scaffold" $infileScaffoldSumStat > ./HZscaffoldparscaffold/tmpsumstatscaff # summary statistics per scaffold
	atgc=$(awk '{print $4}' ./HZscaffoldparscaffold/tmpsumstatscaff) 
	n=$(awk '{print $5}' ./HZscaffoldparscaffold/tmpsumstatscaff)
	totalscaffoldlength1=$(echo "$atgc + $n" |bc)
	totalscaffoldlength2=$(echo "$totalscaffoldlength1" | bc) # total length of the scaffold
	numberofwindows=$(echo "($totalscaffoldlength2 - 1000000 ) / $slidingwindows" | bc) # compute number of windows
	countermini=$(echo "0" | bc)
	countermax=$(echo "1000000" | bc)
	# for each windows, estimate hz
	for j in $(eval echo "{1..$numberofwindows}"); do 
		awk -v threshold="$countermax" '$2 <= threshold' $i | awk -v threshold2="$countermini" '$2 > threshold2' >> tmpcounter
		numberofSNPs=$(less tmpcounter | wc -l)
		rm tmpcounter
		start_res_windows=$(grep "$scaffold	$countermini	" $infileslidingwindowsSumStat) # line sumstat windows
		echo "$start_res_windows" > tmpstartres
		countn=$(awk '{print $6}' tmpstartres)
		proportionofSNPhz=$(echo "$numberofSNPs / 1000000" | bc -l)  # proportion of heterozyguous SNPs
		testN=$(echo "$countn < 200000" | bc)
		if [ $testN = '1' ]; then # if less than 20% N within the window, adjust the estimation by the N rate... else report NA (avoid to inflate the estimate in high N rate regions).
			proportionofSNPhzcor=$(echo "$numberofSNPs / (1000000 - $countn)" | bc -l) # [MODIF = considère une fenetre de 1mb] nombre de bases connues sur la référence
			echo "$scaffold	$countermini	$countermax	$numberofSNPs	$start_res_windows	$proportionofSNPhz	$proportionofSNPhzcor" >> $outfile
		else 
			echo "$scaffold	$countermini	$countermax	$numberofSNPs	$start_res_windows	$proportionofSNPhz	NA" >> $outfile
			echo "$scaffold	$countermini	$countermax -  proportionofSNPhzcor non calculée car $countn >= 200000"
		fi
		countermini=$((countermini+$slidingwindows))
		countermax=$((countermax+$slidingwindows))
	done
done
